var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import container from "./config";
export var FORMAT_IDS = {
    '360p': {
        quality: '60',
        format: '106'
    },
    '480p': {
        quality: '61',
        format: '106'
    },
    '720p': {
        quality: '62',
        format: '106'
    },
    '1080p': {
        quality: '80',
        format: '108'
    }
};
var parseMediaUrl = function (url) {
    var re = /https?:\/\/(?:(www|m)\.)?(crunchyroll\.(?:com|fr)\/(?:media(?:-|\/\?id=)|[^/]*\/[^/?&]*?)([0-9]+))(?:[/?&]|$)/g;
    var match = re.exec(url);
    if (!match)
        throw new Error("Invalid URL");
    return {
        prefix: match[1],
        restUrl: match[2],
        mediaId: match[3]
    };
};
function searchFor(text, start, end) {
    var startIndex = text.indexOf(start);
    if (startIndex === -1)
        throw new Error("Couldn't find start in text");
    text = text.substring(startIndex + start.length);
    var endIndex = text.indexOf(end);
    if (endIndex === -1)
        throw new Error("Couldn't find end in text");
    return text.substring(0, endIndex);
}
export function getMediaByUrl(url, streamFormatOrVideoQuality, streamQualityOrOptions, options) {
    return __awaiter(this, void 0, void 0, function () {
        var quality, format, _a, prefix, mediaId, formatMap, httpClient, response;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = parseMediaUrl(url), prefix = _a.prefix, mediaId = _a.mediaId;
                    if (!(typeof streamFormatOrVideoQuality === "string" && typeof streamQualityOrOptions === "string")) return [3 /*break*/, 1];
                    quality = streamQualityOrOptions;
                    format = streamFormatOrVideoQuality;
                    return [3 /*break*/, 3];
                case 1:
                    formatMap = FORMAT_IDS[streamFormatOrVideoQuality];
                    quality = formatMap.quality;
                    format = formatMap.format;
                    if (!(prefix === "m")) return [3 /*break*/, 3];
                    httpClient = container.get("IHttpClient");
                    return [4 /*yield*/, httpClient.get(url)];
                case 2:
                    response = _b.sent();
                    url = searchFor(response.body, "<link rel=\"canonical\" href=\"", "\" />");
                    mediaId = parseMediaUrl(url).mediaId;
                    _b.label = 3;
                case 3: return [4 /*yield*/, getMedia(mediaId, format, quality, url, options)];
                case 4: return [2 /*return*/, _b.sent()];
            }
        });
    });
}
export function getMedia(mediaId, videoQualityOrStreamFormat, currentPageOrStreamQuality, optionsOrCurrentPage, options) {
    return __awaiter(this, void 0, void 0, function () {
        var streamFormat, streamQuality, currentPage, formatMap, MediaResolver;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (typeof optionsOrCurrentPage === "string") {
                        streamFormat = videoQualityOrStreamFormat;
                        streamQuality = currentPageOrStreamQuality;
                        currentPage = optionsOrCurrentPage;
                    }
                    else {
                        formatMap = FORMAT_IDS[videoQualityOrStreamFormat];
                        streamFormat = formatMap.format;
                        streamQuality = formatMap.quality;
                        currentPage = currentPageOrStreamQuality;
                        options = optionsOrCurrentPage;
                    }
                    MediaResolver = container.get("IMediaResolver");
                    return [4 /*yield*/, MediaResolver.getMedia(mediaId, streamFormat, streamQuality, currentPage, options)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
//# sourceMappingURL=media.js.map