import { ParentNode } from './ParentNode';
import { Attribute } from './Attribute';
import { ClassList } from './ClassList';
export declare class Element extends ParentNode {
    prefix: string | undefined;
    localName: string;
    namespaceURI: string | undefined;
    nodeType: number;
    private _attributes;
    classList: ClassList;
    readonly attributes: {
        [key: string]: Attribute;
    };
    constructor(nodeName: string, prefix: string | undefined, localName: string, attributes: {
        [key: string]: Attribute;
    });
    readonly tagName: string;
    id: string;
    className: string;
    readonly parentElement: Element | undefined;
    readonly nextElementSibling: Element | undefined;
    readonly previousElementSibling: Element | undefined;
    setAttribute(name: string, value: string): void;
    getAttribute(name: string): string;
    hasAttribute(name: string): boolean;
}
