var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
export var SingleAsyncState;
(function (SingleAsyncState) {
    SingleAsyncState[SingleAsyncState["Pending"] = 0] = "Pending";
    SingleAsyncState[SingleAsyncState["Working"] = 1] = "Working";
    SingleAsyncState[SingleAsyncState["Complete"] = 2] = "Complete";
    SingleAsyncState[SingleAsyncState["Error"] = 3] = "Error";
})(SingleAsyncState || (SingleAsyncState = {}));
var SingleAsync = /** @class */ (function () {
    function SingleAsync(fn) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        this._state = SingleAsyncState.Pending;
        this._promises = [];
        this._fn = fn;
        this._args = args;
    }
    SingleAsync.prototype.clear = function () {
        this._state = SingleAsyncState.Pending;
        this._value = undefined;
        this._error = undefined;
        var p;
        while (p = this._promises.shift()) {
            try {
                p.reject(new Error(""));
            }
            catch (e) {
                // Silently fail
            }
        }
    };
    SingleAsync.prototype.get = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            var p;
            return __generator(this, function (_a) {
                if (this._state === SingleAsyncState.Complete) {
                    return [2 /*return*/, this._value];
                }
                else if (this._state === SingleAsyncState.Error) {
                    throw this._error;
                }
                p = new Promise(function (resolve, reject) {
                    _this._promises.push({
                        resolve: resolve,
                        reject: reject
                    });
                });
                if (this._state === SingleAsyncState.Pending) {
                    this._state = SingleAsyncState.Working;
                    this._fn.apply(this, this._args).then(function (value) {
                        _this._value = value;
                        _this._state = SingleAsyncState.Complete;
                        var p;
                        while (p = _this._promises.shift()) {
                            try {
                                p.resolve(value);
                            }
                            catch (e) {
                                // Silently fail
                            }
                        }
                    }, function (reason) {
                        _this._error = reason;
                        _this._state = SingleAsyncState.Error;
                        var p;
                        while (p = _this._promises.shift()) {
                            try {
                                p.reject(reason);
                            }
                            catch (e) {
                                // Silently fail
                            }
                        }
                    });
                }
                return [2 /*return*/, p];
            });
        });
    };
    SingleAsync.prototype.getValue = function () {
        return this._value;
    };
    SingleAsync.prototype.getError = function () {
        return this._error;
    };
    SingleAsync.prototype.getState = function () {
        return this._state;
    };
    return SingleAsync;
}());
export { SingleAsync };
//# sourceMappingURL=SingleAsync.js.map