"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var DOMParser_1 = require("../services/xml/DOMParser");
var SubtitleDecryptor_1 = require("../services/SubtitleDecryptor");
var base64_js_1 = require("base64-js");
var SubtitleResolver = /** @class */ (function () {
    function SubtitleResolver(container) {
        this._httpClient = container.get("IHttpClient");
    }
    SubtitleResolver.prototype.getSubtitleByUrl = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            var response, doc, body, subtitleDecryptionModel, iv, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._httpClient.get(url, {
                            headers: {
                                'Content-Type': 'application/x-www-form-urlencoded'
                            }
                        })];
                    case 1:
                        response = _a.sent();
                        return [4 /*yield*/, (new DOMParser_1.DOMParser()).parseFromString(response.body)];
                    case 2:
                        doc = _a.sent();
                        body = doc.getFirstElement();
                        if (!body)
                            throw new Error("Empty DOM");
                        subtitleDecryptionModel = new SubtitleModel(body);
                        iv = base64_js_1.toByteArray(subtitleDecryptionModel.iv);
                        data = base64_js_1.toByteArray(subtitleDecryptionModel.data);
                        return [2 /*return*/, this.getSubtitle(subtitleDecryptionModel.id, iv, data)];
                }
            });
        });
    };
    SubtitleResolver.prototype.getSubtitle = function (id, iv, data) {
        var decrypter = new SubtitleDecryptor_1.SubtitleDecryptor(id, iv, data);
        return decrypter.decrypt();
    };
    return SubtitleResolver;
}());
exports.SubtitleResolver = SubtitleResolver;
var SubtitleModel = /** @class */ (function () {
    function SubtitleModel(element) {
        this._element = element;
    }
    SubtitleModel.prototype._getValue = function (name) {
        return this._getElement(name).textContent;
    };
    SubtitleModel.prototype._getElement = function (name) {
        var children = this._element.children;
        for (var i = 0; i < children.length; i++) {
            if (children[i].tagName === name) {
                return children[i];
            }
        }
        throw new Error("Unable to get property " + name + " from StreamInfo.");
    };
    Object.defineProperty(SubtitleModel.prototype, "id", {
        get: function () {
            return parseInt(this._element.getAttribute('id'), 10);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleModel.prototype, "iv", {
        get: function () {
            return this._getValue('iv');
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SubtitleModel.prototype, "data", {
        get: function () {
            return this._getValue('data');
        },
        enumerable: true,
        configurable: true
    });
    return SubtitleModel;
}());
exports.SubtitleModel = SubtitleModel;
//# sourceMappingURL=SubtitleResolver.js.map